'use strict';

function dep(baseUrl) {
    // Require.js allows us to configure shortcut alias
    return {
        baseUrl: baseUrl,

        bundles: {
            // "javascripts/common/export.min": [
            //     'javascripts/common/enums',
            //     'javascripts/common/routes'
            // ],
            "javascripts/common/mixed": [
                'javascripts/common/tether.mixed',
                'javascripts/common/toastr.mixed'
            ]
        },

        map: {
            '*': {
                tpl: 'https://cdnjs.cloudflare.com/ajax/libs/requirejs-tpl/0.0.2/tpl.min.js',
                toastr: 'javascripts/common/toastr.mixed',
                tether: 'javascripts/common/tether.mixed',
                postcode: 'javascripts/common/postcode.mixed!',
            },
            'javascripts/common/toastr.mixed': {
                'toastr': 'toastr'
            },
            'javascripts/common/tether.mixed': {
                'tether': 'tether'
            },
        },
        paths: {
            text: 'https://cdnjs.cloudflare.com/ajax/libs/require-text/2.0.12/text.min',
            svg: 'libs/requirejs-svg-0.0.1/svg.min',
            css: 'https://cdnjs.cloudflare.com/ajax/libs/require-css/0.1.8/css.min',
            json: 'https://cdnjs.cloudflare.com/ajax/libs/requirejs-plugins/1.0.3/json.min',
            noext: 'https://cdnjs.cloudflare.com/ajax/libs/requirejs-plugins/1.0.3/noext.min',
            slimscroll: 'https://cdnjs.cloudflare.com/ajax/libs/jQuery-slimScroll/1.3.8/jquery.slimscroll.min',
            jquery: 'https://cdnjs.cloudflare.com/ajax/libs/jquery/3.2.1/jquery.min',
            'jquery.form': 'https://cdnjs.cloudflare.com/ajax/libs/jquery.form/3.51/jquery.form.min',
            'jquery.blockui': 'https://cdnjs.cloudflare.com/ajax/libs/jquery.blockUI/2.70/jquery.blockUI.min',
            underscore: 'https://cdnjs.cloudflare.com/ajax/libs/underscore.js/1.8.3/underscore-min',
            'underscore.string': 'https://cdnjs.cloudflare.com/ajax/libs/underscore.string/3.3.4/underscore.string.min',
            toastr: 'https://cdnjs.cloudflare.com/ajax/libs/toastr.js/2.1.3/toastr.min',
            bootstrap: 'https://cdnjs.cloudflare.com/ajax/libs/twitter-bootstrap/4.0.0-alpha.6/js/bootstrap',
            domReady: 'https://cdnjs.cloudflare.com/ajax/libs/require-domReady/2.0.1/domReady.min',
            backbone: 'https://cdnjs.cloudflare.com/ajax/libs/backbone.js/1.3.3/backbone-min',
            'backbone.paginator': 'https://cdnjs.cloudflare.com/ajax/libs/backbone.paginator/2.0.5/backbone.paginator.min',
            'backbone.bootstrapModal': 'libs/backbone-bootstrap-modal/backbone-bootstrap-modal',
            'backbone.computedfields': 'libs/backbone-computedfields-0.0.11/backbone.computedfields.min',
            moment: 'https://cdnjs.cloudflare.com/ajax/libs/moment.js/2.16.0/moment.min',
            tether: 'https://cdnjs.cloudflare.com/ajax/libs/tether/1.4.0/js/tether',
            'autoNumeric': 'https://cdnjs.cloudflare.com/ajax/libs/autonumeric/1.9.46/autoNumeric.min',
            'browser-update': 'https://browser-update.org/update.min',
        },
        // scripts that do not call define() to register a module
        shim: {
            bootstrap: {
                deps: ['jquery', 'tether'],
                //   exports: "$.fn.tooltip"
            },
            slimscroll: {
                deps: ['jquery'],
                exports: "$.fn.slimScroll"
            },
            underscore: {
                exports: '_'
            },
            backbone: {
                deps: [
                    'underscore',
                    'jquery'
                ],
                exports: 'Backbone'
            },
            'jquery.form': {
                deps: ['jquery'],
                exports: '$.fn.ajaxSubmit'
            },
            toastr: {
                deps: [
                    'css!https://cdnjs.cloudflare.com/ajax/libs/toastr.js/2.1.3/toastr.min'
                ]
            },
            'backbone.computedfields': {
                deps: [
                    'backbone',
                ],
                exports: 'Backbone.ComputedFields',
            },
            'ion.rangeSlider': {
                deps: [
                    'jquery',
                    'css!https://cdnjs.cloudflare.com/ajax/libs/ion-rangeslider/2.1.4/css/ion.rangeSlider.min',
                    'css!https://cdnjs.cloudflare.com/ajax/libs/ion-rangeslider/2.1.4/css/ion.rangeSlider.skinFlat.min'
                ],
                exports: '$.fn.ionRangeSlider'
            }
        }
    };
};