package session

import "bytes"

type userDetail struct {
	id   string
	name string
	mail string
	role Role
}
type UserDetail interface {
	Id() string
	Name() string
	Mail() string
	Role() Role
	ToModelContext() map[string]interface{}
}

func (detail *userDetail) Id() string {
	return detail.id
}
func (detail *userDetail) Name() string {
	return detail.name
}
func (detail *userDetail) Mail() string {
	return detail.mail
}
func (detail *userDetail) Role() Role {
	return detail.role
}

func (detail *userDetail) ToModelContext()map[string]interface{} {
	context:=make(map[string]interface{})
	context["user_id"] = detail.id
	context["user_name"] = detail.name
	context["user_mail"] = detail.mail
	context["user_role"] = detail.role.Type().Name()
	return context
}

func (detail *userDetail) String() string {
	var buffer bytes.Buffer
	buffer.WriteString("UserData(")
	if detail != nil {
		buffer.WriteString("id:")
		buffer.WriteString(detail.id)
		buffer.WriteString("name:")
		buffer.WriteString(detail.name)
		buffer.WriteString("role:")
		if detail.role != nil {
			buffer.WriteString(detail.role.String())
		} else {
			buffer.WriteString("nil")
		}
	} else {
		buffer.WriteString("nil")
	}
	buffer.WriteString(")")
	return buffer.String()
}
