package route

import (
	"net/http"
	"strings"

	"amuz.es/gogs/infra/changer/http/iface"
	"amuz.es/gogs/infra/changer/http/middleware/session"
	"amuz.es/gogs/infra/changer/util"
	"github.com/flosch/pongo2"
	"github.com/gin-gonic/gin"
)

func ChangePassword(c *gin.Context) {
	context := session.ExtractUserDetail(c)
	simplePermissionMatcher(c, session.PermChangePasswordPerm, context)
	var (
		code int
		body = iface.WrappedResponse{}
	)
	defer func() {
		if err := recover(); err != nil {
			panic(err)
		} else {
			util.DumpJSON(c, code, body)
		}
	}()

	var (
		request iface.ChangePassword
	)
	code, body.Message = 406, "요청이 올바르지 않습니다."

	// unboxing
	if err := util.BindJSON(c, &request); err != nil {
		logger.Error(err)
		return
	}

	code, body.Message = 406, "새 암호가 일치하지 않습니다."
	if strings.Compare(request.Password, request.PasswordConfirm) > 0 {
		return
	}
	var (
		err error
	)

	code, body.Message = 403, "ID가 잘못되었거나 기존암호가 일치하지 않습니다."

	if session.Authenticator.ChangePassword(context.Id(), request.OldPassword, request.Password, false) != nil {
		logger.Error(err)
		return
	}
	code, body.Message = 200, "성공"

}

func ChangePasswordView(c *gin.Context) {
	context := session.ExtractUserDetail(c)
	simplePermissionMatcher(c, session.PermChangePasswordPerm, context)

	modelContext:=pongo2.Context{}
	modelContext.Update(context.ToModelContext())
	c.HTML(http.StatusOK, "views/change_password.html", modelContext)
}
