package route

import (
	"errors"
	"net/http"
	"net/url"
	"strings"

	"amuz.es/gogs/infra/changer/enums"
	"amuz.es/gogs/infra/changer/http/middleware/session"
	"github.com/flosch/pongo2"
	"github.com/gin-gonic/gin"
)

func simplePermissionMatcher(c *gin.Context, perm session.ApiPerm, userDetail session.UserDetail) {
	if userDetail == nil || userDetail.Role() == nil {
		panic(errors.New("ResNoAuthenticate"))
	}
	if role := userDetail.Role(); !role.Permit(perm) {
		if role.Type() == enums.UserTypeAnon {
			//로그인 이동
			var (
				prevUrl = *c.Request.URL
			)
			if !strings.Contains(prevUrl.Path, "login") {
				queries:=prevUrl.Query()
				queries.Add("redirectTo", prevUrl.Path)
				moveUrl := url.URL{Path: "./login",RawQuery:queries.Encode()}
				c.Redirect(302, moveUrl.String())
			}
		} else {
			//res = iface.ResInsufficientPerm
			//403

			c.HTML(http.StatusForbidden, "views/error.html", pongo2.Context{
				"code":    http.StatusForbidden,
				"message": http.StatusText(http.StatusForbidden),
			})
		}
	}
}
