package iface

import (
	"github.com/mailru/easyjson/jwriter"
	"github.com/mailru/easyjson/jlexer"
	"amuz.es/gogs/infra/changer/util"
)

var logger = util.NewLogger("common_iface")

type Serializable interface {
	Marshal() ([]byte, error)
	Unmarshal(buf []byte) error
	String() string
}



type JSONSerializable interface {
	MarshalEasyJSON(w *jwriter.Writer)
	UnmarshalEasyJSON(w *jlexer.Lexer)
}